#include <bits/stdc++.h>
#define ll long long
using namespace std;
ll funk(ll a[],ll n,ll k,ll i,ll j,bool p)
{
    ll x=0;
    if(k==0)
    {
        for(ll i1=i;i1<=j;i1++)
            x=(x+a[i1])-(x+a[i1])/(1000000000+7);
        return x;
    }
    if(i==j&&!p) return a[i];
    p=false;
    for(;i<n;i++)
    {
        for(j=i;j<n;j++)
        {
            ll p=funk(a,n,k-1,i,j,p);
            x=(x+p)-(x+p)/(1000000000+7);
        }
    }
    return x;
}
int main()
{
    ios::sync_with_stdio(false);cin.tie(NULL);cout.tie(NULL);
    ll n,k;
    cin>>n>>k;
    ll a[n];
    for(ll i=0;i<n;i++)cin>>a[i];
    if(k==0)
    {
        ll s=a[0];
        for(int i=1;i<n;i++) s=(s+a[i])-(s+a[i])/(1000000000+7);
        cout<<s;
    }
    else
    {
        cout<<funk(a,n,k,0,0,true);
    }
}